﻿/*
 Basic ESP32 MQTT
 ESP32_MQTT_A25_REMOTE
 */
#include <WiFi.h>
#include <PubSubClient.h>

// Update these with values suitable for your network.
const char* ssid = "NETxxx";
const char* password = "pwxxxx";
const char* mqtt_server = "192.168.xxx.xxx"; //ip-adresse von Mosquitto MQTT-Message-Broker

WiFiClient espClient;
PubSubClient client(espClient);
long lastMsg = 0;
char msg[50];
int value = 0;

char incomingByte =0;

void setup() {
  pinMode(BUILTIN_LED, OUTPUT);     // Initialize the BUILTIN_LED pin as an output
  Serial.begin(115200);
  setup_wifi();
  client.setServer(mqtt_server, 1883);
  client.setCallback(callback);
  //Versionspflege
  Serial.println("ESP32_MQTT_A25_REMOTE_V1");
}

void setup_wifi() {

  delay(10);
  // We start by connecting to a WiFi network
  Serial.println();
  Serial.print("Connecting to ");
  Serial.println(ssid);

  WiFi.begin(ssid, password);

  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }

  Serial.println("");
  Serial.println("WiFi connected");
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());
}

void callback(char* topic, byte* payload, unsigned int length) {
  Serial.print("Message arrived [");
  Serial.print(topic);
  Serial.print("] ");
  for (int i = 0; i < length; i++) {
    Serial.print((char)payload[i]);
  }
  Serial.println();

  // Switch on the LED if an 1 was received as first character
  if ((char)payload[0] == '1') {
    digitalWrite(BUILTIN_LED, LOW);   // Turn the LED on (Note that LOW is the voltage level
    // but actually the LED is on; this is because
    // it is acive low on the ESP-01)
  } else {
    digitalWrite(BUILTIN_LED, HIGH);  // Turn the LED off by making the voltage HIGH
  }

}

void reconnect() {
  // Loop until we're reconnected
  while (!client.connected()) {
    Serial.print("Attempting MQTT connection...");
    // Attempt to connect
    if (client.connect("ESP32C2")) {
      Serial.println("connected");
      // Once connected, publish an announcement...
      client.publish("outTopic", "hello world");
      // ... and resubscribe
      client.subscribe("inTopic");
      client.subscribe("a25H");
    } else {
      Serial.print("failed, rc=");
      Serial.print(client.state());
      Serial.println(" try again in 5 seconds");
      // Wait 5 seconds before retrying
      delay(5000);
    }
  }
}
void loop() {

  if (!client.connected()) {
    reconnect();
  }
  client.loop();


  if (Serial.available() > 0)   //Tasteneingaben
   {
    incomingByte = Serial.read();
    if (incomingByte == 'h')
     {
      Serial.println("Menü (h)"); 
      Serial.println("i Informationen "); 
      Serial.println("p Parameter ");
      Serial.println("x Remote off ");
      Serial.println("z Reset erzwingen ");
      Serial.println("e ESC Pfeil nach links "); 
      Serial.println("r RET Pfeil nach rechts "); 
      Serial.println("s Relais Tropfoeler  "); 
      Serial.println("o ESC Pfeil nach oben "); 
      Serial.println("u ESC Pfeil nach unten "); 
      snprintf (msg, 50, "h Menü");
      client.publish("a25c", msg);
     }
    if (incomingByte == 'z')
     {
      //software_Reset() ;
      snprintf (msg, 50, "z Reset erzwingen");
      client.publish("a25c", msg);
     }
    if (incomingByte == 'i')
     {
      snprintf (msg, 50, "i Informationen");
      client.publish("a25c", msg);
     }

    if (incomingByte == 'p')
     { 
      snprintf (msg, 50, "p Parameter");
      client.publish("a25c", msg);
     }
    if (incomingByte == 'x')
     {
      snprintf (msg, 50, "x Remote off");
      client.publish("a25c", msg);
     }
    if (incomingByte == 'e')
     {       
      //Serial.println("ESC Pfeil links "); 
      snprintf (msg, 50, "e ESC Pfeil nach links");
      client.publish("a25c", msg);
     }    
    if (incomingByte == 'r')
     {       
      //Serial.println("RET Pfeil rechts "); 
      snprintf (msg, 50, "r RET Pfeil nach rechts");
      client.publish("a25c", msg);
     }

    if (incomingByte == 's')
     {       
      //Serial.println("Tropfoeler ein "); 
      snprintf (msg, 50, "s Relais Tropfoeler");
      client.publish("a25c", msg);
     }
     
    if (incomingByte == 'o')
     {       
      //Serial.println("RET Pfeil oben "); 
      snprintf (msg, 50, "o ESC Pfeil nach oben");
      client.publish("a25c", msg);
     }    
    if (incomingByte == 'u')
     {       
      //Serial.println("RET Pfeil ab "); 
      snprintf (msg, 50, "u ESC Pfeil nach unten");
      client.publish("a25c", msg);
     }
    Serial.flush(); 
   } // Ende Serial.available() > 0 ende Tasteneingaben

  long now = millis();
  if (now - lastMsg > 9000) {
    lastMsg = now;
    ++value;
    Serial.print("Publish message: (letzte gesendete) ");
    Serial.println(msg);
  }
}
